// FirmwareFile.h: interface for the CFirmwareFile class.
//
//////////////////////////////////////////////////////////////////////
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is FirmwareFile.h.
 *
 * The Initial Developer of the Original Code is
 * Fenestra Software LLC.
 * Portions created by the Initial Developer are Copyright (C) 2002 Fenestra Software LLC
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
#if !defined(AFX_FIRMWAREFILE_H__3037EF22_15C8_4431_B656_7CE68694E232__INCLUDED_)
#define AFX_FIRMWAREFILE_H__3037EF22_15C8_4431_B656_7CE68694E232__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// Class to encapsulate the memory maping of the firmware file.
class CFirmwareFile  
{
public:
	LPSTR gets(LPSTR buff, int bufflen);
	void Close();
	BOOL Open(LPSTR FileName);
	CFirmwareFile();
	virtual ~CFirmwareFile();

private:
	BY_HANDLE_FILE_INFORMATION m_FileInfo;
	unsigned int m_iCurrPos;
	LPSTR m_pFileData;
	HANDLE m_MappingHandle;
	HANDLE m_FileHandle;
};

#endif // !defined(AFX_FIRMWAREFILE_H__3037EF22_15C8_4431_B656_7CE68694E232__INCLUDED_)
