// RCX_Command.h: interface for the RCX_Command class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RCX_COMMAND_H__D02FF7D2_4F2C_40C5_B2D6_1FB21C484EB4__INCLUDED_)
#define AFX_RCX_COMMAND_H__D02FF7D2_4F2C_40C5_B2D6_1FB21C484EB4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

const BYTE DirRev = 0x00;
const BYTE DirAlt = 0x40;
const BYTE DirFwd = 0x80;

const BYTE MotFlt = 0x00;
const BYTE MotOn  = 0x80;
const BYTE MotOff = 0x40;

const BYTE pbPlayToneVar			= 0x02;	// OK
const BYTE pbDirectEvent			= 0x03;
const BYTE pbCalibrateEvent			= 0x04;
const BYTE pbSetSourceValue			= 0x05;
const BYTE pbClearAllEvents			= 0x06;	// OK	-P
const BYTE pbPBAliveOrNot			= 0x10;	// OK	-P
const BYTE pbPoll					= 0x12;	// OK
const BYTE pbSetPower				= 0x13;	// OK	-P
const BYTE pbSetVar					= 0x14;	// OK	-P
const BYTE pbUnlockPBrick			= 0x15;	// OK
const BYTE pbGosub					= 0x17;	// OK	-P
const BYTE pbMemMap					= 0x20;	// OK
const BYTE pbOnOffFloat				= 0x21;	// OK	-P
const BYTE pbSetWatch				= 0x22;	// OK	-P
const BYTE pbPlayTone				= 0x23;	// OK	-P
const BYTE pbSumVar					= 0x24;	// OK	-P
const BYTE pbBeginOfTask			= 0x25;	// OK
const BYTE pbSJump					= 0x27;	// OK	-P
const BYTE pbPBBattery				= 0x30;	// OK
const BYTE pbPbTXPower				= 0x31;	// OK	-P
const BYTE pbSetSensorType			= 0x32;	// OK	-P
const BYTE pbSelectDisplay			= 0x33;	// OK	-P
const BYTE pbSubVar					= 0x34;	// OK	-P
const BYTE pbBeginOfSub				= 0x35;	// OK
const BYTE pbSCheckLoopCounter		= 0x37;	// OK	-P
const BYTE pbDeleteAllTasks			= 0x40;	// OK
const BYTE pbSetSensorMode			= 0x42;	// OK	-P
const BYTE pbWait					= 0x43;	// OK	-P
const BYTE pbDivVar					= 0x44;	// OK	-P
const BYTE pbContinueDownLoad		= 0x45;	// OK
const BYTE pbStopAllTasks			= 0x50;	// OK	-P
const BYTE pbPlaySystemSound		= 0x51;	// OK	-P
const BYTE pbSetDataLog				= 0x52;	// OK	-P
const BYTE pbMulVar					= 0x54;	// OK	-P
const BYTE pbPBTurnOff				= 0x60;	// OK	-P
const BYTE pbDeleteTask				= 0x61;	// OK
const BYTE pbDataLogNext			= 0x62;	// OK	-P
const BYTE pbUploadRam				= 0x63;
const BYTE pbSgnVar					= 0x64;	// OK	-P
const BYTE pbGoIntoBootMode			= 0x65;	// OK
const BYTE pbConnectDisconnect		= 0x67;
const BYTE pbDeleteAllSubs			= 0x70;	// OK
const BYTE pbStartTask				= 0x71;	// OK	-P
const BYTE pbLJump					= 0x72;	// OK	-P
const BYTE pbEnterAccessControl		= 0x73;
const BYTE pbAbsVar					= 0x74;	// OK	-P
const BYTE pbBeginFirmwareDownLoad	= 0x75;	// OK
const BYTE pbSetNormSetInvAltDir	= 0x77;
const BYTE pbClearSound				= 0x80;
const BYTE pbStopTask				= 0x81;	// OK	-P
const BYTE pbSetLoopCounter			= 0x82;	// OK	-P
const BYTE pbAndVar					= 0x84;	// OK	-P
const BYTE pbSCheckDo				= 0x85;
const BYTE pbClearPBMessage			= 0x90;	// OK	-P
const BYTE pbSelectProgram			= 0x91;	// OK	-P
const BYTE pbLCheckLoopCounter		= 0x92;	// OK	-P
const BYTE pbSetEvent				= 0x93;
const BYTE pbOrVar					= 0x94;	// OK	-P
const BYTE pbLCheckDo				= 0x95;	// OK	-P
const BYTE pbIncCounter				= 0x97;
const BYTE pbExitAccessControl		= 0xA0;
const BYTE pbClearTimer				= 0xA1;	// OK	-P
const BYTE pbSetMaxPower			= 0xA3;
const BYTE pbUpload					= 0xA4;	// OK
const BYTE pbUnlockFirmware			= 0xA5;	// OK
const BYTE pbDecCounter				= 0xA7;
const BYTE pbExitEventCheck			= 0xB0;
const BYTE pbPBPowerDownTime		= 0xB1;	// OK	-P
const BYTE pbSendPBMessage			= 0xB2;	// OK	-P
const BYTE pbSEnterEventCheck		= 0xB4;
const BYTE pbLEnterEventCheck		= 0xB5;
const BYTE pbClearCounter			= 0xB7;
const BYTE pbDeleteSub				= 0xC1;	// OK
const BYTE pbSendUARTData			= 0xC2;
const BYTE pbMuteSound				= 0xD0;
const BYTE pbClearSensorValue		= 0xD1;	// OK	-P
const BYTE pbRemoteCommand			= 0xD2;
const BYTE pbSetPriority			= 0xD7;
const BYTE pbUnmuteSound			= 0xE0;
const BYTE pbSetFwdSetRwdRewDir		= 0xE1;	// OK	-P
const BYTE pbViewSourceValue		= 0xE5;
const BYTE pbSDecVarJumpLTZero		= 0xF2;	// OK	-P
const BYTE pbLDecVarJumpLTZero		= 0xF3;	// OK	-P
const BYTE pbEndOfSub				= 0xF6;	// OK
const BYTE pbInternMessage			= 0xF7;	// OK	-P

class RCX_Command  
{
public:
	RCX_Command();
	RCX_Command(BYTE Command);
	RCX_Command(BYTE Command, BYTE A1);
	RCX_Command(BYTE Command, BYTE A1, BYTE A2);
	RCX_Command(BYTE Command, BYTE A1, BYTE A2, BYTE A3);
	RCX_Command(BYTE Command, BYTE A1, BYTE A2, BYTE A3, BYTE A4);
	RCX_Command(BYTE Command, BYTE A1, BYTE A2, BYTE A3, BYTE A4, BYTE A5);
	virtual ~RCX_Command();

public:
	inline void Set(BYTE Command)
	{
		m_Buff[0] = Command;
	}
	inline void Set(BYTE Command, BYTE A1)
	{
		m_Buff[1] = A1;
		Set(Command);
	}
	inline void Set(BYTE Command, BYTE A1, BYTE A2)
	{
		m_Buff[2] = A2;
		Set(Command, A1);
	}
	inline void Set(BYTE Command, BYTE A1, BYTE A2, BYTE A3)
	{
		m_Buff[3] = A3;
		Set(Command, A1, A2);
	}
	inline void Set(BYTE Command, BYTE A1, BYTE A2, BYTE A3, BYTE A4)
	{
		m_Buff[4] = A4;
		Set(Command, A1, A2, A3);
	}
	inline void Set(BYTE Command, BYTE A1, BYTE A2, BYTE A3, BYTE A4, BYTE A5)
	{
		m_Buff[5] = A5;
		Set(Command, A1, A2, A3, A4);
	}

	inline BYTE * GetBody()
	{
		return m_Buff;
	}

	private:
		BYTE m_Buff[10];
	};

#endif // !defined(AFX_RCX_COMMAND_H__D02FF7D2_4F2C_40C5_B2D6_1FB21C484EB4__INCLUDED_)
